
/******************************************************************************
* MODULE     : tag_info.hpp
* DESCRIPTION: DRD information about tags
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef TAG_INFO_H
#define TAG_INFO_H
#include "tree.hpp"

class tag_info_rep: concrete_struct {
public:
  string name;  // name of the tag
  int    arity; // arity of the tag (-1 if several arities are possible)
  int    props; // properties of the tag

  tag_info_rep (string name, int arity, int props);

  friend class tag_info;
};

class tag_info {
  CONCRETE(tag_info);
  tag_info (string name, int arity, int props= 0);
  operator tree ();
};
CONCRETE_CODE(tag_info);

bool operator != (tag_info ti1, tag_info ti2);
ostream& operator << (ostream& out, tag_info ti);
tag_info copy (tag_info ti);

#endif // defined TAG_INFO_H
